Foreman - Bug #30394

50/50 chance to create role filter with non-admin user and enough permissions
07/14/2020 07:29 AM - Shira Maximov

Status: Closed
Priority: Normal
Assignee: Ondrej Ezr
Category: Users, Roles and Permissions
Target version: 251
Difficulty: Fixed in Releases: 2.5.1,3.0.0
Triaged: No Found in Releases:
Bugzilla link: 1845498 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/g422,
https://github.com/theforeman/foreman/p
ull/8616
Description

Cloned from https://bugzilla.redhat.com/show_bug.cqgi?id=1845498

Description of problem:

The error "Could not create the permission filter:

You don't have permission create_filters with attributes that you have specified or you don't have access to specified organizations or
locations" is printed sometimes even with enough permissions for execution of the command:

1. hammer --config configFile.yml --output json filter create --role roleName --permissions "permissionName"

Version-Release number of selected component (if applicable):
hammer 0.17.1

How reproducible:
hammer will sometimes success and sometimes not. When in loop you may see fails and success with not changed user role.

Steps to Reproduce:
1. Create Satellite user x
2. Create a /root/.hammer/cli_test.yml config file with the following content:

foreman:

:host: <hostname>
:username: <userName>
:password: <password>

3. Create Role and add permissions below to the user created in the step 1.

(Miscellaneous) escalate_roles

Auth source view_authenticators

Bookmark view_bookmarks, create_bookmarks, edit_bookmarks, destroy_bookmarks

External usergroup view_external_usergroups, create_external_usergroups, edit_external_usergroups,
destroy_external_usergroups

Filter view_filters, create_filters, edit_filters, destroy_filters
Organization view_organizations
Role view_roles, create_roles, edit_roles, destroy_roles

Subscription attach_subscriptions, unattach_subscriptions
Usergroup view_usergroups, create_usergroups, edit_usergroups, destroy_usergroups

4. Add Role from 3. to user from 1.
5. Create new role

1. hammer --config /root/.hammer/cli_test.yml role create --name test_role --organizations <organization>

6. Create new filter for test_role
1. hammer --config /root/.hammer/cli_test.yml filter create --role test_role --permissions "access_dashboard"

Actual results:

Sometimes

"Could not create the permission filter:

You don't have permission create_filters with attributes that you have specified or you don't have access to specified organizations or
locations"

Sometimes
"Permission filter for [] created.”

Expected results:
"Permission filter for [] created.”

Associated revisions

Revision 2a0ad914 - 06/18/2021 12:31 PM - Ondfej Ezr

Fixes #30394 - allow non-admins deal with untaxed filters

Prior this non-admin user would have to have assigned Role without
taxonomies (global role) to be able to manipulate filters.
This allows manipulating Filters to any User with Filter perms.

Filters with taxonomies mean they apply to taxonomy. But given they have
taxonomies relations, they are expected to be taxable in our permission
model. All taxable resources have to have the same taxonomies as Filter
have.

Some filters doesn't have taxonomies as their underlying resource
doesn't have taxonomies. That mean they were unable to be touched by
non-admins prior this patch.

This also drops current taxonomy relations in migration and force flip
the "Override’ flag to false for Filter resource filters.

Revision 44764290 - 06/18/2021 12:31 PM - Ondfej Ezr
Refs #30394 - rename taxable checks
This renames the taxable check methods on Filter to better express

what they mean. We want to know it the resource is taxable, not if it
has search on taxonomy.

History

#1 - 07/22/2020 09:56 AM - Tomer Brisker

- Category set to Users, Roles and Permissions

#2 - 03/31/2021 09:06 PM - Ondfej Ezr

In development this always fails because of taxonomies.
Filter look like taxable, even though they are not taxable, their taxonomy assignment means "Filter applies to taxonomies".

This should be IMHO fixed by disabling taxonomy check on Filter permission checking.

#3 - 03/31/2021 09:15 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ondrej Ezr

- Pull request https://github.com/theforeman/foreman/pull/8422 added

#4 - 06/18/2021 12:31 PM - The Foreman Bot
- Fixed in Releases 3.0.0 added

#5 - 06/18/2021 12:32 PM - The Foreman Bot
- Fixed in Releases deleted (3.0.0)

#6 - 06/18/2021 01:08 PM - Ondfrej Ezr
- Status changed from Ready For Testing to Closed

Applied in changeset foreman|2a0ad9140655b1c1604ddb948dcal0c3e5968a42c.

#7 - 06/22/2021 09:41 AM - Tomer Brisker
- Fixed in Releases 3.0.0 added

#8 - 06/23/2021 09:51 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/8616 added

#9 - 06/23/2021 09:53 AM - Tomer Brisker

- Target version set to 2.5.1

#10 - 06/23/2021 12:24 PM - Tomer Brisker
- Fixed in Releases 2.5.1 added

05/17/2024 3/3


https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/2a0ad9140655b1c1604ddb948dca0c3e5968a42c
http://www.tcpdf.org

